searchData={"items":[{"type":"module","title":"Mktree","doc":"Mktree is a high-performance library that implements Merkle Trees using Rust + Elixir. It provides efficient cryptographic hashing and validation of data, making it suitable for blockchain applications and secure data structures.","ref":"Mktree.html"},{"type":"function","title":"Mktree.build_tree/1","doc":"Builds a complete Merkle tree from a list of hashed leaves.\nReturns a list of layers, where each layer is a list of hashes.\nThe first layer are the initial leaves, the last is the root.\n\nUsage:\n```elixir\niex> Mktree.build_tree([\"hash1\", \"hash2\", \"hash3\", \"hash4\"])\n[[\"hash1\", \"hash2\", \"hash3\", \"hash4\"], [\"d8eab8000c5826fbf21e6340c96a911c7cf362c054695b73cb1a80ad0dac1cb0\", ...]]\n```","ref":"Mktree.html#build_tree/1"},{"type":"function","title":"Mktree.compute_root/1","doc":"Computes the Merkle Root from a list of data leaves.\nFirst hashes the leaves and then builds the tree to get the root.\nUsage:\n```elixir\niex> root = Mktree.compute_root([\"hash1\", \"hash2\", \"hash3\", \"hash4\"])\n\"93b46a24b0a418c5f6c31b4058dc5d0f3338a30951d3b4b5a74e9072f145c766\"\n```","ref":"Mktree.html#compute_root/1"},{"type":"function","title":"Mktree.generate_proof/2","doc":"Generates a Merkle proof for a specific data leaf.\nReturns a list of tuples (sibling_hash, is_left_sibling).\nUsage:\n```elixir\niex> proof = Mktree.generate_proof([\"hash1\", \"hash2\", \"hash3\", \"hash4\"], \"hash1\")\n[{\"e7bf382f6e5915b3f88619b866223ebf1d51c4c5321cccde2e9ff700a3259086\", false}, ...]\n```","ref":"Mktree.html#generate_proof/2"},{"type":"function","title":"Mktree.hash_leaf/1","doc":"hashing of individual leaves","ref":"Mktree.html#hash_leaf/1"},{"type":"function","title":"Mktree.verify_proof/3","doc":"Verifies a Merkle proof for a given leaf.\nReturns true if the proof is valid, false otherwise.\nUsage:\n```elixir\niex> Mktree.verify_proof(\"hash1\", proof, root)\ntrue\n```","ref":"Mktree.html#verify_proof/3"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}